ORACLE_FACTORY_ABI = [
  {
    "inputs": [
      {
        "internalType": "address",
        "name": "implementation_",
        "type": "address"
      }
    ],
    "stateMutability": "nonpayable",
    "type": "constructor"
  },
  {
    "inputs": [],
    "name": "FactoryNotInstanceError",
    "type": "error"
  },
  {
    "inputs": [
      {
        "internalType": "uint256",
        "name": "version",
        "type": "uint256"
      }
    ],
    "name": "InitializableAlreadyInitializedError",
    "type": "error"
  },
  {
    "inputs": [],
    "name": "InitializableNotInitializingError",
    "type": "error"
  },
  {
    "inputs": [],
    "name": "InitializableZeroVersionError",
    "type": "error"
  },
  {
    "inputs": [],
    "name": "OracleFactoryAlreadyCreatedError",
    "type": "error"
  },
  {
    "inputs": [],
    "name": "OracleFactoryInvalidIdError",
    "type": "error"
  },
  {
    "inputs": [],
    "name": "OracleFactoryNotCreatedError",
    "type": "error"
  },
  {
    "inputs": [],
    "name": "OracleFactoryNotRegisteredError",
    "type": "error"
  },
  {
    "inputs": [],
    "name": "OracleParameterStorageInvalidError",
    "type": "error"
  },
  {
    "inputs": [],
    "name": "OwnableAlreadyInitializedError",
    "type": "error"
  },
  {
    "inputs": [
      {
        "internalType": "address",
        "name": "sender",
        "type": "address"
      }
    ],
    "name": "OwnableNotOwnerError",
    "type": "error"
  },
  {
    "inputs": [
      {
        "internalType": "address",
        "name": "sender",
        "type": "address"
      }
    ],
    "name": "OwnableNotPendingOwnerError",
    "type": "error"
  },
  {
    "inputs": [
      {
        "internalType": "address",
        "name": "sender",
        "type": "address"
      }
    ],
    "name": "PausableNotPauserError",
    "type": "error"
  },
  {
    "inputs": [],
    "name": "PausablePausedError",
    "type": "error"
  },
  {
    "anonymous": "false",
    "inputs": [
      {
        "indexed": "false",
        "internalType": "contract IFactory",
        "name": "caller",
        "type": "address"
      }
    ],
    "name": "CallerAuthorized",
    "type": "event"
  },
  {
    "anonymous": "false",
    "inputs": [
      {
        "indexed": "false",
        "internalType": "contract IOracleProviderFactory",
        "name": "factory",
        "type": "address"
      }
    ],
    "name": "FactoryRegistered",
    "type": "event"
  },
  {
    "anonymous": "false",
    "inputs": [
      {
        "indexed": "false",
        "internalType": "uint256",
        "name": "version",
        "type": "uint256"
      }
    ],
    "name": "Initialized",
    "type": "event"
  },
  {
    "anonymous": "false",
    "inputs": [
      {
        "indexed": "true",
        "internalType": "contract IInstance",
        "name": "instance",
        "type": "address"
      }
    ],
    "name": "InstanceRegistered",
    "type": "event"
  },
  {
    "anonymous": "false",
    "inputs": [
      {
        "indexed": "true",
        "internalType": "contract IOracleProvider",
        "name": "oracle",
        "type": "address"
      },
      {
        "indexed": "true",
        "internalType": "bytes32",
        "name": "id",
        "type": "bytes32"
      }
    ],
    "name": "OracleCreated",
    "type": "event"
  },
  {
    "anonymous": "false",
    "inputs": [
      {
        "indexed": "true",
        "internalType": "address",
        "name": "newOwner",
        "type": "address"
      }
    ],
    "name": "OwnerUpdated",
    "type": "event"
  },
  {
    "anonymous": "false",
    "inputs": [],
    "name": "Paused",
    "type": "event"
  },
  {
    "anonymous": "false",
    "inputs": [
      {
        "indexed": "true",
        "internalType": "address",
        "name": "newPauser",
        "type": "address"
      }
    ],
    "name": "PauserUpdated",
    "type": "event"
  },
  {
    "anonymous": "false",
    "inputs": [
      {
        "indexed": "true",
        "internalType": "address",
        "name": "newPendingOwner",
        "type": "address"
      }
    ],
    "name": "PendingOwnerUpdated",
    "type": "event"
  },
  {
    "anonymous": "false",
    "inputs": [],
    "name": "Unpaused",
    "type": "event"
  },
  {
    "inputs": [],
    "name": "acceptOwner",
    "outputs": [],
    "stateMutability": "nonpayable",
    "type": "function"
  },
  {
    "inputs": [
      {
        "internalType": "bytes32",
        "name": "id",
        "type": "bytes32"
      },
      {
        "internalType": "contract IOracleProviderFactory",
        "name": "factory",
        "type": "address"
      },
      {
        "internalType": "string",
        "name": "name",
        "type": "string"
      }
    ],
    "name": "create",
    "outputs": [
      {
        "internalType": "contract IOracle",
        "name": "newOracle",
        "type": "address"
      }
    ],
    "stateMutability": "nonpayable",
    "type": "function"
  },
  {
    "inputs": [
      {
        "internalType": "contract IOracleProviderFactory",
        "name": "",
        "type": "address"
      }
    ],
    "name": "factories",
    "outputs": [
      {
        "internalType": "bool",
        "name": "",
        "type": "bool"
      }
    ],
    "stateMutability": "view",
    "type": "function"
  },
  {
    "inputs": [
      {
        "internalType": "contract IOracleProvider",
        "name": "",
        "type": "address"
      }
    ],
    "name": "ids",
    "outputs": [
      {
        "internalType": "bytes32",
        "name": "",
        "type": "bytes32"
      }
    ],
    "stateMutability": "view",
    "type": "function"
  },
  {
    "inputs": [],
    "name": "implementation",
    "outputs": [
      {
        "internalType": "address",
        "name": "",
        "type": "address"
      }
    ],
    "stateMutability": "view",
    "type": "function"
  },
  {
    "inputs": [],
    "name": "initialize",
    "outputs": [],
    "stateMutability": "nonpayable",
    "type": "function"
  },
  {
    "inputs": [
      {
        "internalType": "contract IInstance",
        "name": "instance",
        "type": "address"
      }
    ],
    "name": "instances",
    "outputs": [
      {
        "internalType": "bool",
        "name": "",
        "type": "bool"
      }
    ],
    "stateMutability": "view",
    "type": "function"
  },
  {
    "inputs": [
      {
        "internalType": "bytes32",
        "name": "",
        "type": "bytes32"
      }
    ],
    "name": "oracles",
    "outputs": [
      {
        "internalType": "contract IOracleProvider",
        "name": "",
        "type": "address"
      }
    ],
    "stateMutability": "view",
    "type": "function"
  },
  {
    "inputs": [],
    "name": "owner",
    "outputs": [
      {
        "internalType": "address",
        "name": "",
        "type": "address"
      }
    ],
    "stateMutability": "view",
    "type": "function"
  },
  {
    "inputs": [],
    "name": "parameter",
    "outputs": [
      {
        "components": [
          {
            "internalType": "uint256",
            "name": "maxGranularity",
            "type": "uint256"
          },
          {
            "internalType": "UFixed6",
            "name": "maxSettlementFee",
            "type": "uint256"
          },
          {
            "internalType": "UFixed6",
            "name": "maxOracleFee",
            "type": "uint256"
          }
        ],
        "internalType": "struct OracleParameter",
        "name": "",
        "type": "tuple"
      }
    ],
    "stateMutability": "view",
    "type": "function"
  },
  {
    "inputs": [],
    "name": "pause",
    "outputs": [],
    "stateMutability": "nonpayable",
    "type": "function"
  },
  {
    "inputs": [],
    "name": "paused",
    "outputs": [
      {
        "internalType": "bool",
        "name": "",
        "type": "bool"
      }
    ],
    "stateMutability": "view",
    "type": "function"
  },
  {
    "inputs": [],
    "name": "pauser",
    "outputs": [
      {
        "internalType": "address",
        "name": "",
        "type": "address"
      }
    ],
    "stateMutability": "view",
    "type": "function"
  },
  {
    "inputs": [],
    "name": "pendingOwner",
    "outputs": [
      {
        "internalType": "address",
        "name": "",
        "type": "address"
      }
    ],
    "stateMutability": "view",
    "type": "function"
  },
  {
    "inputs": [
      {
        "internalType": "contract IOracleProviderFactory",
        "name": "factory",
        "type": "address"
      }
    ],
    "name": "register",
    "outputs": [],
    "stateMutability": "nonpayable",
    "type": "function"
  },
  {
    "inputs": [],
    "name": "unpause",
    "outputs": [],
    "stateMutability": "nonpayable",
    "type": "function"
  },
  {
    "inputs": [
      {
        "internalType": "bytes32",
        "name": "id",
        "type": "bytes32"
      },
      {
        "internalType": "contract IOracleProviderFactory",
        "name": "factory",
        "type": "address"
      }
    ],
    "name": "update",
    "outputs": [],
    "stateMutability": "nonpayable",
    "type": "function"
  },
  {
    "inputs": [
      {
        "internalType": "contract IOracleProvider",
        "name": "oracleProvider",
        "type": "address"
      },
      {
        "internalType": "bytes32",
        "name": "id",
        "type": "bytes32"
      }
    ],
    "name": "updateId",
    "outputs": [],
    "stateMutability": "nonpayable",
    "type": "function"
  },
  {
    "inputs": [
      {
        "components": [
          {
            "internalType": "uint256",
            "name": "maxGranularity",
            "type": "uint256"
          },
          {
            "internalType": "UFixed6",
            "name": "maxSettlementFee",
            "type": "uint256"
          },
          {
            "internalType": "UFixed6",
            "name": "maxOracleFee",
            "type": "uint256"
          }
        ],
        "internalType": "struct OracleParameter",
        "name": "newParameter",
        "type": "tuple"
      }
    ],
    "name": "updateParameter",
    "outputs": [],
    "stateMutability": "nonpayable",
    "type": "function"
  },
  {
    "inputs": [
      {
        "internalType": "address",
        "name": "newPauser",
        "type": "address"
      }
    ],
    "name": "updatePauser",
    "outputs": [],
    "stateMutability": "nonpayable",
    "type": "function"
  },
  {
    "inputs": [
      {
        "internalType": "address",
        "name": "newPendingOwner",
        "type": "address"
      }
    ],
    "name": "updatePendingOwner",
    "outputs": [],
    "stateMutability": "nonpayable",
    "type": "function"
  },
  {
    "inputs": [
      {
        "internalType": "Token18",
        "name": "token",
        "type": "address"
      }
    ],
    "name": "withdraw",
    "outputs": [],
    "stateMutability": "nonpayable",
    "type": "function"
  }
]