PYTH_ORACLE_ABI = [
    {
        "inputs": [
            {
                "internalType": "contract AbstractPyth",
                "name": "_pyth",
                "type": "address"
            }
        ],
        "stateMutability": "nonpayable",
        "type": "constructor"
    },
    {
        "inputs": [],
        "name": "DivisionByZero",
        "type": "error"
    },
    {
        "inputs": [
            {
                "internalType": "uint256",
                "name": "value",
                "type": "uint256"
            }
        ],
        "name": "Fixed6OverflowError",
        "type": "error"
    },
    {
        "inputs": [
            {
                "internalType": "address",
                "name": "sender",
                "type": "address"
            }
        ],
        "name": "InstanceNotOwnerError",
        "type": "error"
    },
    {
        "inputs": [],
        "name": "InstancePausedError",
        "type": "error"
    },
    {
        "inputs": [],
        "name": "OracleProviderUnauthorizedError",
        "type": "error"
    },
    {
        "inputs": [],
        "name": "PythOracleFailedToCalculateRewardError",
        "type": "error"
    },
    {
        "inputs": [],
        "name": "PythOracleFailedToSendRewardError",
        "type": "error"
    },
    {
        "inputs": [],
        "name": "PythOracleGracePeriodHasNotExpiredError",
        "type": "error"
    },
    {
        "inputs": [
            {
                "internalType": "bytes32",
                "name": "id",
                "type": "bytes32"
            }
        ],
        "name": "PythOracleInvalidPriceIdError",
        "type": "error"
    },
    {
        "inputs": [],
        "name": "PythOracleNoNewVersionToCommitError",
        "type": "error"
    },
    {
        "inputs": [],
        "name": "PythOracleNonIncreasingPublishTimes",
        "type": "error"
    },
    {
        "inputs": [],
        "name": "PythOracleNonRequestedTooRecentError",
        "type": "error"
    },
    {
        "inputs": [],
        "name": "PythOracleUpdateValidForPreviousVersionError",
        "type": "error"
    },
    {
        "inputs": [],
        "name": "PythOracleVersionIndexTooLowError",
        "type": "error"
    },
    {
        "inputs": [],
        "name": "PythOracleVersionOutsideRangeError",
        "type": "error"
    },
    {
        "inputs": [
            {
                "internalType": "int256",
                "name": "value",
                "type": "int256"
            }
        ],
        "name": "UFixed18UnderflowError",
        "type": "error"
    },
    {
        "inputs": [
            {
                "internalType": "uint256",
                "name": "version",
                "type": "uint256"
            }
        ],
        "name": "UInitializableAlreadyInitializedError",
        "type": "error"
    },
    {
        "inputs": [],
        "name": "UInitializableNotInitializingError",
        "type": "error"
    },
    {
        "inputs": [],
        "name": "UInitializableZeroVersionError",
        "type": "error"
    },
    {
        "anonymous": False,
        "inputs": [
            {
                "indexed": False,
                "internalType": "uint256",
                "name": "version",
                "type": "uint256"
            }
        ],
        "name": "Initialized",
        "type": "event"
    },
    {
        "anonymous": False,
        "inputs": [
            {
                "indexed": True,
                "internalType": "address",
                "name": "sender",
                "type": "address"
            },
            {
                "indexed": False,
                "internalType": "uint256",
                "name": "gasUsed",
                "type": "uint256"
            },
            {
                "indexed": False,
                "internalType": "UFixed18",
                "name": "multiplier",
                "type": "uint256"
            },
            {
                "indexed": False,
                "internalType": "uint256",
                "name": "buffer",
                "type": "uint256"
            },
            {
                "indexed": False,
                "internalType": "UFixed18",
                "name": "keeperFee",
                "type": "uint256"
            }
        ],
        "name": "KeeperCall",
        "type": "event"
    },
    {
        "anonymous": False,
        "inputs": [
            {
                "indexed": True,
                "internalType": "uint256",
                "name": "version",
                "type": "uint256"
            }
        ],
        "name": "OracleProviderVersionFulfilled",
        "type": "event"
    },
    {
        "anonymous": False,
        "inputs": [
            {
                "indexed": True,
                "internalType": "uint256",
                "name": "version",
                "type": "uint256"
            }
        ],
        "name": "OracleProviderVersionRequested",
        "type": "event"
    },
    {
        "inputs": [],
        "name": "ARB_FIXED_OVERHEAD",
        "outputs": [
            {
                "internalType": "uint256",
                "name": "",
                "type": "uint256"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "ARB_GAS_MULTIPLIER",
        "outputs": [
            {
                "internalType": "uint256",
                "name": "",
                "type": "uint256"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "GRACE_PERIOD",
        "outputs": [
            {
                "internalType": "uint256",
                "name": "",
                "type": "uint256"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "KEEPER_BUFFER",
        "outputs": [
            {
                "internalType": "uint256",
                "name": "",
                "type": "uint256"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "KEEPER_REWARD_PREMIUM",
        "outputs": [
            {
                "internalType": "UFixed18",
                "name": "",
                "type": "uint256"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "MAX_VALID_TIME_AFTER_VERSION",
        "outputs": [
            {
                "internalType": "uint256",
                "name": "",
                "type": "uint256"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "MIN_VALID_TIME_AFTER_VERSION",
        "outputs": [
            {
                "internalType": "uint256",
                "name": "",
                "type": "uint256"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [
            {
                "internalType": "uint256",
                "name": "timestamp",
                "type": "uint256"
            }
        ],
        "name": "at",
        "outputs": [
            {
                "components": [
                    {
                        "internalType": "uint256",
                        "name": "timestamp",
                        "type": "uint256"
                    },
                    {
                        "internalType": "Fixed6",
                        "name": "price",
                        "type": "int256"
                    },
                    {
                        "internalType": "bool",
                        "name": "valid",
                        "type": "bool"
                    }
                ],
                "internalType": "struct OracleVersion",
                "name": "oracleVersion",
                "type": "tuple"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [
            {
                "internalType": "uint256",
                "name": "versionIndex",
                "type": "uint256"
            },
            {
                "internalType": "uint256",
                "name": "oracleVersion",
                "type": "uint256"
            },
            {
                "internalType": "bytes",
                "name": "updateData",
                "type": "bytes"
            }
        ],
        "name": "commit",
        "outputs": [],
        "stateMutability": "payable",
        "type": "function"
    },
    {
        "inputs": [
            {
                "internalType": "uint256",
                "name": "versionIndex",
                "type": "uint256"
            },
            {
                "internalType": "bytes",
                "name": "updateData",
                "type": "bytes"
            }
        ],
        "name": "commitRequested",
        "outputs": [],
        "stateMutability": "payable",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "current",
        "outputs": [
            {
                "internalType": "uint256",
                "name": "",
                "type": "uint256"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "ethTokenOracleFeed",
        "outputs": [
            {
                "internalType": "contract AggregatorV3Interface",
                "name": "",
                "type": "address"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "factory",
        "outputs": [
            {
                "internalType": "contract IFactory",
                "name": "",
                "type": "address"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "id",
        "outputs": [
            {
                "internalType": "bytes32",
                "name": "",
                "type": "bytes32"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [
            {
                "internalType": "bytes32",
                "name": "id_",
                "type": "bytes32"
            },
            {
                "internalType": "contract AggregatorV3Interface",
                "name": "chainlinkFeed_",
                "type": "address"
            },
            {
                "internalType": "Token18",
                "name": "dsu_",
                "type": "address"
            }
        ],
        "name": "initialize",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "keeperToken",
        "outputs": [
            {
                "internalType": "Token18",
                "name": "",
                "type": "address"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "lastCommittedPublishTime",
        "outputs": [
            {
                "internalType": "uint256",
                "name": "",
                "type": "uint256"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "latest",
        "outputs": [
            {
                "components": [
                    {
                        "internalType": "uint256",
                        "name": "timestamp",
                        "type": "uint256"
                    },
                    {
                        "internalType": "Fixed6",
                        "name": "price",
                        "type": "int256"
                    },
                    {
                        "internalType": "bool",
                        "name": "valid",
                        "type": "bool"
                    }
                ],
                "internalType": "struct OracleVersion",
                "name": "latestVersion",
                "type": "tuple"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "nextVersionIndexToCommit",
        "outputs": [
            {
                "internalType": "uint256",
                "name": "",
                "type": "uint256"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "nextVersionToCommit",
        "outputs": [
            {
                "internalType": "uint256",
                "name": "version",
                "type": "uint256"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [
            {
                "internalType": "uint256",
                "name": "",
                "type": "uint256"
            }
        ],
        "name": "publishTimes",
        "outputs": [
            {
                "internalType": "uint256",
                "name": "",
                "type": "uint256"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "pyth",
        "outputs": [
            {
                "internalType": "contract AbstractPyth",
                "name": "",
                "type": "address"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [
            {
                "internalType": "address",
                "name": "",
                "type": "address"
            }
        ],
        "name": "request",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "status",
        "outputs": [
            {
                "components": [
                    {
                        "internalType": "uint256",
                        "name": "timestamp",
                        "type": "uint256"
                    },
                    {
                        "internalType": "Fixed6",
                        "name": "price",
                        "type": "int256"
                    },
                    {
                        "internalType": "bool",
                        "name": "valid",
                        "type": "bool"
                    }
                ],
                "internalType": "struct OracleVersion",
                "name": "",
                "type": "tuple"
            },
            {
                "internalType": "uint256",
                "name": "",
                "type": "uint256"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [
            {
                "internalType": "uint256",
                "name": "",
                "type": "uint256"
            }
        ],
        "name": "versionList",
        "outputs": [
            {
                "internalType": "uint256",
                "name": "",
                "type": "uint256"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    },
    {
        "inputs": [],
        "name": "versionListLength",
        "outputs": [
            {
                "internalType": "uint256",
                "name": "",
                "type": "uint256"
            }
        ],
        "stateMutability": "view",
        "type": "function"
    }
]